/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2008.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: include/sgx/core/platform/hwplatform.hpp

*/

#ifndef SGX_CORE_PLATFORM_HPP
#define SGX_CORE_PLATFORM_HPP 

#define SGX_KILOBYTES   (1024)
#define SGX_MEGABYTES   (1024*1024)

class CHardwarePlatform {
public:
    typedef enum { eBigEndian=0, eLittleEndian=1 } tEndian;
public:
    static CHardwarePlatform   *get();

    virtual const char *getPlatform()=0;
    virtual const char *getPlatformID()=0;
    virtual const char *getDocsURL()=0;
    virtual const char *getDevelopmentURL()=0;
    virtual tREAL32     getDiscAccessSpeed()=0;     // in seconds
    virtual tREAL32     getDiscReadSpeed()=0;       // in bytes/second
    virtual tEndian     getEndian()=0;
    virtual tUINT32     getNumCPUs()=0;
    virtual tUINT32     getCPUSpeed(tUINT32 type=0)=0;
    virtual tUINT32     getNumMemoryBanks()=0;
    virtual tUINT32     getMemorySize(tUINT32 type=0)=0;

    virtual void	    getCRLF(tBYTE *);

    virtual void        dumpStats();

protected:
    CHardwarePlatform();

	static CHardwarePlatform   *ms_pSingleton;
};

#endif /* SGX_CORE_PLATFORM_HPP */